## cups 2.3.1

=== Makefile ===
#
# Top-level Makefile for CUPS.
#
# Copyright © 2007-2019 by Apple Inc.
# Copyright © 1997-2007 by Easy Software Products, all rights reserved.
#
# Licensed under Apache License v2.0.  See the file "LICENSE" for more
# information.
#

include Makedefs


#
# Directories to make...
#

DIRS	=	cups $(BUILDDIRS)


#
# Test suite options - normally blank, override with make command...
#

TESTOPTIONS	=


#
# Make all targets...
#

all:
	chmod +x cups-config
	echo Using ARCHFLAGS="$(ARCHFLAGS)"
	echo Using ALL_CFLAGS="$(ALL_CFLAGS)"
	echo Using ALL_CXXFLAGS="$(ALL_CXXFLAGS)"
	echo Using CC="$(CC)"
	echo Using CXX="$(CC)"
	echo Using DSOFLAGS="$(DSOFLAGS)"
	echo Using LDFLAGS="$(LDFLAGS)"
	echo Using LIBS="$(LIBS)"
	for dir in $(DIRS); do\
		echo Making all in $$dir... ;\
		(cd $$dir ; $(MAKE) $(MFLAGS) all $(UNITTESTS)) || exit 1;\
	done


#
# Make library targets...
#

libs:
	echo Using ARCHFLAGS="$(ARCHFLAGS)"
	echo Using ALL_CFLAGS="$(ALL_CFLAGS)"
	echo Using ALL_CXXFLAGS="$(ALL_CXXFLAGS)"
	echo Using CC="$(CC)"
	echo Using CXX="$(CC)"
	echo Using DSOFLAGS="$(DSOFLAGS)"
	echo Using LDFLAGS="$(LDFLAGS)"
	echo Using LIBS="$(LIBS)"
	for dir in $(DIRS); do\
		echo Making libraries in $$dir... ;\
		(cd $$dir ; $(MAKE) $(MFLAGS) libs) || exit 1;\
	done


#
# Make unit test targets...
#

unittests:
	echo Using ARCHFLAGS="$(ARCHFLAGS)"
	echo Using ALL_CFLAGS="$(ALL_CFLAGS)"
	echo Using ALL_CXXFLAGS="$(ALL_CXXFLAGS)"
	echo Using CC="$(CC)"
	echo Using CXX="$(CC)"
	echo Using DSOFLAGS="$(DSOFLAGS)"
	echo Using LDFLAGS="$(LDFLAGS)"
	echo Using LIBS="$(LIBS)"
	for dir in $(DIRS); do\
		echo Making all in $$dir... ;\
		(cd $$dir ; $(MAKE) $(MFLAGS) unittests) || exit 1;\
	done


#
# Remove object and target files...
#

clean:
	for dir in $(DIRS); do\
		echo Cleaning in $$dir... ;\
		(cd $$dir; $(MAKE) $(MFLAGS) clean) || exit 1;\
	done


#
# Remove all non-distribution files...
#

distclean:	clean
	$(RM) Makedefs config.h config.log config.status
	$(RM) conf/cups-files.conf conf/cupsd.conf conf/mime.convs conf/pam.std conf/snmp.conf
	$(RM) cups-config
	$(RM) desktop/cups.desktop
	$(RM) doc/index.html
	$(RM) packaging/cups.list
	$(RM) scheduler/cups-lpd.xinetd scheduler/cups.sh scheduler/cups.xml scheduler/org.cups.cups-lpd.plist scheduler/org.cups.cups-lpdAT.service scheduler/org.cups.cupsd.path scheduler/org.cups.cupsd.service scheduler/org.cups.cupsd.socket
	$(RM) templates/header.tmpl
	-$(RM) doc/*/index.html
	-$(RM) templates/*/header.tmpl
	-$(RM) -r autom4te*.cache cups/charmaps cups/locale


#
# Make dependencies
#

depend:
	for dir in $(DIRS); do\
		echo Making dependencies in $$dir... ;\
		(cd $$dir; $(MAKE) $(MFLAGS) depend) || exit 1;\
	done


#
# Run the STACK tool on the sources, available here:
#
#    http://css.csail.mit.edu/stack/
#
# Do the following to pass options to configure:
#
#    make CONFIGFLAGS="--foo --bar" stack
#

.PHONY: stack
stack:
	stack-build ./configure $(CONFIGFLAGS)
	stack-build $(MAKE) $(MFLAGS) clean all
	poptck
	$(MAKE) $(MFLAGS) distclean
	$(RM) */*.ll
	$(RM) */*.ll.out


#
# Generate a ctags file...
#

ctags:
	ctags -R .


#
# Install everything...
#

install:	install-data install-headers install-libs install-exec


#
# Install data files...
#

install-data:
	echo Making all in cups...
	(cd cups; $(MAKE) $(MFLAGS) all)
	for dir in $(DIRS); do\
		echo Installing data files in $$dir... ;\
		(cd $$dir; $(MAKE) $(MFLAGS) install-data) || exit 1;\
	done
	echo Installing cups-config script...
	$(INSTALL_DIR) -m 755 $(BINDIR)
	$(INSTALL_SCRIPT) cups-config $(BINDIR)/cups-config


#
# Install header files...
#

install-headers:
	for dir in $(DIRS); do\
		echo Installing header files in $$dir... ;\
		(cd $$dir; $(MAKE) $(MFLAGS) install-headers) || exit 1;\
	done
	if test "x$(privateinclude)" != x; then \
		echo Installing config.h into $(PRIVATEINCLUDE)...; \
		$(INSTALL_DIR) -m 755 $(PRIVATEINCLUDE); \
		$(INSTALL_DATA) config.h $(PRIVATEINCLUDE)/config.h; \
	fi


#
# Install programs...
#

install-exec:	all
	for dir in $(DIRS); do\
		echo Installing programs in $$dir... ;\
		(cd $$dir; $(MAKE) $(MFLAGS) install-exec) || exit 1;\
	done


#
# Install libraries...
#

install-libs:	libs
	for dir in $(DIRS); do\
		echo Installing libraries in $$dir... ;\
		(cd $$dir; $(MAKE) $(MFLAGS) install-libs) || exit 1;\
	done


#
# Uninstall object and target files...
#

uninstall:
	for dir in $(DIRS); do\
		echo Uninstalling in $$dir... ;\
		(cd $$dir; $(MAKE) $(MFLAGS) uninstall) || exit 1;\
	done
	echo Uninstalling cups-config script...
	$(RM) $(BINDIR)/cups-config
	-$(RMDIR) $(BINDIR)


#
# Run the test suite...
#

test:	all unittests
	echo Running CUPS test suite...
	cd test; ./run-stp-tests.sh $(TESTOPTIONS)


check:	all unittests
	echo Running CUPS test suite with defaults...
	cd test; ./run-stp-tests.sh 1 0 n n

debugcheck:	all unittests
	echo Running CUPS test suite with debug printfs...
	cd test; ./run-stp-tests.sh 1 0 n y


#
# Create HTML documentation using codedoc (http://www.msweet.org/codedoc)...
#

apihelp:
	for dir in cups filter; do\
		echo Generating API help in $$dir... ;\
		(cd $$dir; $(MAKE) $(MFLAGS) apihelp) || exit 1;\
	done


#
# Lines of code computation...
#

sloc:
	for dir in cups scheduler; do \
		(cd $$dir; $(MAKE) $(MFLAGS) sloc) || exit 1;\
	done


#
# Make software distributions using EPM (http://www.msweet.org/)...
#

EPMFLAGS	=	-v --output-dir dist $(EPMARCH)

bsd deb epm pkg rpm slackware:
	epm $(EPMFLAGS) -f $@ cups packaging/cups.list

.PHONY:	dist
dist:	all
	$(RM) -r dist
	$(MAKE) $(MFLAGS) epm
	case `uname` in \
		*BSD*) $(MAKE) $(MFLAGS) bsd;; \
		Linux*) test ! -x /usr/bin/rpm || $(MAKE) $(MFLAGS) rpm;; \
		SunOS*) $(MAKE) $(MFLAGS) pkg;; \
	esac


#
# Don't run top-level build targets in parallel...
#

.NOTPARALLEL:

=== backend/Makefile ===
#
# Backend makefile for CUPS.
#
# Copyright 2007-2019 by Apple Inc.
# Copyright 1997-2007 by Easy Software Products, all rights reserved.
#
# Licensed under Apache License v2.0.  See the file "LICENSE" for more information.
#

include ../Makedefs

#
# Object files...
#

# RBACKENDS are installed mode 0700 so cupsd will run them as root...
#
# UBACKENDS and ULBACKENDS are installed mode 0755 so cupsd will run them as
# an unprivileged user...
#
# See http://www.cups.org/doc/api-filter.html for more info...
RBACKENDS =	\
		ipp \
		lpd \
		$(DNSSD_BACKEND)
UBACKENDS =	\
		snmp \
		socket
ULBACKENDS =	\
		usb
UNITTESTS =	\
		test1284 \
		testbackend \
		testsupplies
TARGETS =	\
		libbackend.a \
		$(RBACKENDS) \
		$(UBACKENDS) \
		$(ULBACKENDS)
LIBOBJS	=	\
		ieee1284.o \
		network.o \
		runloop.o \
		snmp-supplies.o
OBJS	=	\
		ipp.o \
		lpd.o \
		dnssd.o \
		snmp.o \
		socket.o \
		test1284.o \
		testbackend.o \
		testsupplies.o \
		usb.o


#
# Make all targets...
#

all:	$(TARGETS)


#
# Make library targets...
#

libs:	$(ULBACKENDS)


#
# Make unit tests...
#

unittests:	$(UNITTESTS)


#
# Clean all object files...
#

clean:
	$(RM) $(OBJS) $(TARGETS) $(UNITTESTS) $(LIBOBJS) http https ipps mdns socket-static


#
# Update dependencies (without system header dependencies...)
#

depend:
	$(CC) -MM $(ALL_CFLAGS) $(OBJS:.o=.c) >Dependencies


#
# Install all targets...
#

install:	all install-data install-headers install-libs install-exec


#
# Install data files...
#

install-data:
	if test "x$(USBQUIRKS)" != x; then \
		echo Installing USB quirks in $(USBQUIRKS); \
		$(INSTALL_DIR) -m 755 $(USBQUIRKS); \
		$(INSTALL_DATA) org.cups.usb-quirks $(USBQUIRKS); \
	fi


#
# Install programs...
#

install-exec:	$(INSTALLXPC)
	echo Installing backends in $(SERVERBIN)/backend
	$(INSTALL_DIR) -m 755 $(SERVERBIN)/backend
	for file in $(RBACKENDS); do \
		$(LIBTOOL) $(INSTALL_BIN) -m 700 $$file $(SERVERBIN)/backend; \
	done
	for file in $(UBACKENDS); do \
		$(INSTALL_BIN) $$file $(SERVERBIN)/backend; \
	done
	for file in $(IPPALIASES); do \
		$(RM) $(SERVERBIN)/backend/$$file; \
		$(LN) ipp $(SERVERBIN)/backend/$$file; \
	done
	if test "x$(DNSSD_BACKEND)" != x -a `uname` = Darwin; then \
		$(RM) $(SERVERBIN)/backend/mdns; \
		$(LN) $(DNSSD_BACKEND) $(SERVERBIN)/backend/mdns; \
	fi
	if test "x$(SYMROOT)" != "x"; then \
		$(INSTALL_DIR) $(SYMROOT); \
		for file in $(RBACKENDS) $(UBACKENDS); do \
			cp $$file $(SYMROOT); \
			dsymutil $(SYMROOT)/$$file; \
		done \
	fi

install-xpc:	ipp
	echo Installing XPC backends in $(SERVERBIN)/apple
	$(INSTALL_DIR) -m 755 $(SERVERBIN)/apple
	$(LIBTOOL) $(INSTALL_BIN) ipp $(SERVERBIN)/apple
	for file in $(IPPALIASES); do \
		$(RM) $(SERVERBIN)/apple/$$file; \
		$(LN) ipp $(SERVERBIN)/apple/$$file; \
	done


#
# Install headers...
#

install-headers:


#
# Install libraries...
#

install-libs:
	echo Installing backends in $(SERVERBIN)/backend
	$(INSTALL_DIR) -m 755 $(SERVERBIN)/backend
	for file in $(ULBACKENDS); do \
		$(INSTALL_BIN) $$file $(SERVERBIN)/backend; \
	done
	if test "x$(SYMROOT)" != "x"; then \
		$(INSTALL_DIR) $(SYMROOT); \
		for file in $(ULBACKENDS); do \
			cp $$file $(SYMROOT); \
			dsymutil $(SYMROOT)/$$file; \
		done \
	fi


#
# Uninstall all targets...
#

uninstall:
	$(RM) $(SERVERBIN)/apple/ipp
	for file in $(IPPALIASES); do \
		$(RM) $(SERVERBIN)/apple/$$file; \
	done
	-$(RMDIR) $(SERVERBIN)/apple
	for file in $(RBACKENDS) $(UBACKENDS) $(ULBACKENDS); do \
		$(RM) $(SERVERBIN)/backend/$$file; \
	done
	for file in $(IPPALIASES); do \
		$(RM) $(SERVERBIN)/backend/$$file; \
	done
	-$(RMDIR) $(SERVERBIN)/backend
	-$(RMDIR) $(SERVERBIN)


#
# test1284
#

test1284:	test1284.o ../cups/$(LIBCUPSSTATIC)
	echo Linking $@...
	$(LD_CC) $(ALL_LDFLAGS) -o test1284 test1284.o $(LINKCUPSSTATIC)
	$(CODE_SIGN) -s "$(CODE_SIGN_IDENTITY)" $@


#
# testbackend
#

testbackend:	testbackend.o ../cups/$(LIBCUPSSTATIC)
	echo Linking $@...
	$(LD_CC) $(ALL_LDFLAGS) -o testbackend testbackend.o $(LINKCUPSSTATIC)
	$(CODE_SIGN) -s "$(CODE_SIGN_IDENTITY)" $@


#
# testsupplies
#

testsupplies:	testsupplies.o libbackend.a ../cups/$(LIBCUPSSTATIC)
	echo Linking $@...
	$(LD_CC) $(ALL_LDFLAGS) -o testsupplies testsupplies.o libbackend.a \
		$(LINKCUPSSTATIC)
	$(CODE_SIGN) -s "$(CODE_SIGN_IDENTITY)" $@


#
# libbackend.a
#

libbackend.a:	$(LIBOBJS)
	echo Archiving $@...
	$(RM) $@
	$(AR) $(ARFLAGS) $@ $(LIBOBJS)
	$(RANLIB) $@


#
# dnssd
#

dnssd:	dnssd.o ../cups/$(LIBCUPS) libbackend.a
	echo Linking $@...
	$(LD_CC) $(ALL_LDFLAGS) -o dnssd dnssd.o libbackend.a $(DNSSDLIBS) $(LINKCUPS)
	$(CODE_SIGN) -s "$(CODE_SIGN_IDENTITY)" $@
	if test `uname` = Darwin; then \
		$(RM) mdns; \
		$(LN) dnssd mdns; \
	fi


#
# ipp
#

ipp:	ipp.o ../cups/$(LIBCUPS) libbackend.a
	echo Linking $@...
	$(LD_CC) $(ALL_LDFLAGS) -o ipp ipp.o libbackend.a $(LINKCUPS)
	$(CODE_SIGN) -s "$(CODE_SIGN_IDENTITY)" $@
	$(RM) http https ipps
	for file in $(IPPALIASES); do \
		$(LN) ipp $$file; \
	done


#
# lpd
#

lpd:	lpd.o ../cups/$(LIBCUPS) libbackend.a
	echo Linking $@...
	$(LD_CC) $(ALL_LDFLAGS) -o lpd lpd.o libbackend.a $(LINKCUPS)
	$(CODE_SIGN) -s "$(CODE_SIGN_IDENTITY)" $@


#
# snmp
#

snmp:	snmp.o ../cups/$(LIBCUPS) libbackend.a
	echo Linking $@...
	$(LD_CC) $(ALL_LDFLAGS) -o snmp snmp.o libbackend.a $(LINKCUPS)
	$(CODE_SIGN) -s "$(CODE_SIGN_IDENTITY)" $@


#
# socket
#

socket:	socket.o ../cups/$(LIBCUPS) libbackend.a
	echo Linking $@...
	$(LD_CC) $(ALL_LDFLAGS) -o socket socket.o libbackend.a $(LINKCUPS)
	$(CODE_SIGN) -s "$(CODE_SIGN_IDENTITY)" $@

socket-static:	socket.o  ../cups/$(LIBCUPSSTATIC) libbackend.a
	echo Linking $@...
	$(LD_CC) $(ALL_LDFLAGS) -o socket-static socket.o libbackend.a \
		$(LINKCUPSSTATIC)
	$(CODE_SIGN) -s "$(CODE_SIGN_IDENTITY)" $@


#
# usb
#

usb:	usb.o ../cups/$(LIBCUPS) libbackend.a
	echo Linking $@...
	$(LD_CC) $(ARCHFLAGS) $(ALL_LDFLAGS) -o usb usb.o libbackend.a $(LIBUSB) \
		$(BACKLIBS) $(COMMONLIBS) $(LINKCUPS)
	$(CODE_SIGN) -s "$(CODE_SIGN_IDENTITY)" $@
usb.o:	usb.c usb-darwin.c usb-libusb.c usb-unix.c


#
# Dependencies...
#

include Dependencies

=== debian/changelog ===
cups (2.3.1-9ubuntu1.9) focal-security; urgency=medium

  * SECURITY UPDATE: PPD injection issues (LP: #2082335)
    - debian/patches/sec-202409-1.patch: validate URIs, attribute names,
      and capabilities in cups/ppd-cache.c, scheduler/ipp.c.
    - debian/patches/sec-202409-2.patch: sanitize make and model in
      cups/ppd-cache.c.
    - debian/patches/sec-202409-3.patch: PPDize preset and template names
      in cups/ppd-cache.c.
    - debian/patches/sec-202409-4.patch: quote PPD localized strings in
      cups/ppd-cache.c.
    - debian/patches/sec-202409-5.patch: fix warnings in cups/ppd-cache.c.
    - CVE number pending

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 26 Sep 2024 08:44:22 -0400

cups (2.3.1-9ubuntu1.8) focal-security; urgency=medium

  * SECURITY REGRESSION: early exit on missing listen directive
    - d/p/fix-scheduler-start-if-only-domain-socket-to-listen.patch: don't
      exit if no valid Listen or Port found (LP: #2070315)

 -- Sudhakar Verma <sudhakar.verma@canonical.com>  Thu, 27 Jun 2024 18:40:32 +0530

cups (2.3.1-9ubuntu1.7) focal-security; urgency=medium

  * SECURITY UPDATE: cupsd listen arbitrary chmod 0140777
    - debian/patches/CVE-2024-35235.patch: validate status of unlink and bind
      in cups/http-addr.c
    - CVE-2024-35235 

 -- Sudhakar Verma <sudhakar.verma@canonical.com>  Sun, 23 Jun 2024 02:43:24 +0530

cups (2.3.1-9ubuntu1.6) focal-security; urgency=medium

  * SECURITY UPDATE: Postscript parsing heap overflow
    - debian/patches/CVE-2023-4504.patch: properly check for end of buffer
      in cups/raster-interpret.c.
    - CVE-2023-4504

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 15 Sep 2023 07:20:26 -0400

cups (2.3.1-9ubuntu1.5) focal-security; urgency=medium

  * SECURITY UPDATE: recently printed documents authentication issue
    - debian/patches/CVE-2023-32360.patch: require authentication for
      CUPS-Get-Document in conf/cupsd.conf.in.
    - CVE-2023-32360

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 11 Sep 2023 12:30:19 -0400

cups (2.3.1-9ubuntu1.4) focal-security; urgency=medium

  * SECURITY UPDATE: use-after-free in cupsdAcceptClient()
    - debian/patches/CVE-2023-34241.patch: log result of httpGetHostname
      BEFORE closing the connection in scheduler/client.c.
    - CVE-2023-34241

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 13 Jun 2023 08:17:47 -0400

cups (2.3.1-9ubuntu1.3) focal-security; urgency=medium

  * SECURITY UPDATE: DoS via buffer overflow in format_log_line
    - debian/patches/CVE-2023-32324.patch: check _cups_strlcpy size in
      cups/string.c.
    - CVE-2023-32324

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 25 May 2023 08:43:14 -0400

cups (2.3.1-9ubuntu1.2) focal-security; urgency=medium

  * SECURITY UPDATE: buffer overflow in ippReadIO
    - debian/patches/CVE-2019-8842.patch: fix check in cups/ipp.c.
    - CVE-2019-8842
  * SECURITY UPDATE: buffer overflow in ippReadIO
    - debian/patches/CVE-2020-10001.patch: fix bounds checks in cups/ipp.c.
    - CVE-2020-10001
  * SECURITY UPDATE: Local authorization cert bypass
    - debian/patches/CVE-2022-26691-1.patch: fix string comparison in
      scheduler/cert.c.
    - debian/patches/CVE-2022-26691-2.patch: fix the comment in
      scheduler/cert.c.
    - CVE-2022-26691

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 27 May 2022 10:51:54 -0400

cups (2.3.1-9ubuntu1.1) focal-security; urgency=medium

  * SECURITY UPDATE: heap-based buffer overflow
    - debian/patches/CVE-2020-3898.patch: properly handle invalid
      resolution names in cups/ppd.c, ppdc/ppdc-source.cxx.
    - CVE-2020-3898

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Fri, 24 Apr 2020 10:37:14 -0400

cups (2.3.1-9ubuntu1) focal; urgency=medium

  * Revert all the CI test changes
  * Add the bug fixes (not CI test changes of 2.3.1-10:
    - Add Requires=cups.socket to cups.service, to make sure they start in
      the right order
    - Add patch proposal from RedHat to fix leakage of ppd (Issue: #5738)

 -- Till Kamppeter <till.kamppeter@gmail.com>  Mon, 24 Feb 2020 16:45:01 +0100

cups (2.3.1-9) unstable; urgency=medium

  * CI Tests: Ensure the job files are non-empty; should detect more
    regressions

 -- Didier Raboud <odyx@debian.org>  Sat, 22 Feb 2020 17:19:46 +0100

cups (2.3.1-8) unstable; urgency=medium

  * Add patch to fix cupsctl when loading cupsd.conf (Issue: #5744)

 -- Didier Raboud <odyx@debian.org>  Sat, 22 Feb 2020 14:34:48 +0100

cups (2.3.1-7) unstable; urgency=medium

  * Add patch to fix conversion of PPD InputSlot choice names; this should fix
    printers ignoring the paper tray selection (Issue: #5740, Closes: #949315)
  * lintian-brush:
    - Set upstream metadata fields: Bug-Database, Repository, Repository-Browse
    - Rewrap some d/changelog entries

 -- Didier Raboud <odyx@debian.org>  Mon, 17 Feb 2020 09:19:56 +0100

cups (2.3.1-6) unstable; urgency=medium

  * Patch test suite to also ignore 'Job held' lines in error_log line
    counting

 -- Didier Raboud <odyx@debian.org>  Sat, 08 Feb 2020 11:52:44 +0100

cups (2.3.1-5) unstable; urgency=medium

  * Move towards driverless-centered installation:
    - Drop all printer-driver-* and hplip recommends/suggests
  * Cleanup all versions from pre- Debian stable
  * Bump S-V to 4.5.0 without changes needed

 -- Didier Raboud <odyx@debian.org>  Fri, 07 Feb 2020 17:08:48 +0100

cups (2.3.1-4) unstable; urgency=medium

  * Cleanup patch queue for cups' bts URLs and patch names
  * Update README.Debian to remove leftover SystemdIdleExit references

 -- Didier Raboud <odyx@debian.org>  Thu, 30 Jan 2020 20:35:47 +0100

cups (2.3.1-2) unstable; urgency=medium

  * Drop pwg-raster-attributes.patch
  * Amend 2.3.1-1 changelog entry to add missing Ubuntu package drop and CVE
    bug closure

 -- Didier Raboud <odyx@debian.org>  Sun, 26 Jan 2020 15:23:24 +0100

cups (2.3.1-1) unstable; urgency=medium

  [ Didier Raboud ]


=== debian/control ===
Source: cups
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Printing Team <debian-printing@lists.debian.org>
Uploaders: Didier Raboud <odyx@debian.org>,
           Till Kamppeter <till.kamppeter@gmail.com>
Section: net
Priority: optional
Build-Depends: debhelper-compat (= 12),
               dh-apparmor,
               patch,
               autoconf,
               automake,
               libtool,
               pkg-config,
               ghostscript,
               libavahi-client-dev,
               libavahi-common-dev,
               libavahi-compat-libdnssd-dev,
               libdbus-1-dev,
               libfontconfig1-dev,
               libfreetype6-dev,
               libgnutls28-dev,
               libijs-dev,
               libjpeg-dev,
               libldap2-dev,
               libkrb5-dev,
               libpam0g-dev,
               libpaper-dev,
               libpng-dev,
               libsystemd-dev [linux-any],
               libtiff-dev,
               libusb-1.0-0-dev [!hurd-any],
               po4a,
               po-debconf,
               poppler-utils,
               sharutils,
               zlib1g-dev
# libgmp-dev is not GPL-2 compatible before it's 6 release, which makes it also GPL-2+
Build-Conflicts: libgmp-dev (<< 2:6)
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/printing-team/cups
Vcs-Git: https://salsa.debian.org/printing-team/cups.git
Homepage: https://www.cups.org/
Rules-Requires-Root: no

Package: libcups2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: cups-common
Pre-Depends: ${misc:Pre-Depends}
Description: Common UNIX Printing System(tm) - Core library
 The Common UNIX Printing System (or CUPS(tm)) is a printing system and
 general replacement for lpd and the like.  It supports the Internet
 Printing Protocol (IPP), and has its own filtering driver model for
 handling various document types.
 .
 This package provides the base shared libraries for CUPS.

Package: libcupsimage2
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libcups2 (= ${binary:Version})
Recommends: libcupsfilters1
Pre-Depends: ${misc:Pre-Depends}
Description: Common UNIX Printing System(tm) - Raster image library
 The Common UNIX Printing System (or CUPS(tm)) is a printing system and
 general replacement for lpd and the like.  It supports the Internet
 Printing Protocol (IPP), and has its own filtering driver model for
 handling various document types.
 .
 This package provides the image libraries for handling the CUPS
 raster format.

Package: cups
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends},
         ${misc:Depends},
         cups-core-drivers (>= ${binary:Version}),
         cups-daemon (>= ${binary:Version}),
         debconf | debconf-2.0,
         poppler-utils,
         procps,
         ghostscript,
         cups-common (>= ${source:Version}),
         cups-server-common (>= ${source:Version}),
         cups-client (>= ${binary:Version}),
         libcups2 (= ${binary:Version}),
         cups-ppdc,
         cups-filters
Recommends: avahi-daemon,
            colord,
            cups-filters | foomatic-filters,
            cups-filters | ghostscript-cups
Suggests: cups-bsd,
          foomatic-db-compressed-ppds | foomatic-db,
          cups-pdf,
          udev,
          smbclient
Pre-Depends: ${misc:Pre-Depends}
Description: Common UNIX Printing System(tm) - PPD/driver support, web interface
 The Common UNIX Printing System (or CUPS(tm)) is a printing system and
 general replacement for lpd and the like.  It supports the Internet
 Printing Protocol (IPP), and has its own filtering driver model for
 handling various document types.
 .
 This package provides the parts of CUPS which are needed for using printer
 drivers.

Package: cups-core-drivers
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends},
         ${misc:Depends},
         cups-daemon (>= ${binary:Version}),
         libcups2 (= ${binary:Version}),
         cups-filters-core-drivers
Recommends: avahi-daemon
Pre-Depends: ${misc:Pre-Depends}
Breaks: cups-server-common (<< 2.1.0-7~)
Replaces: cups-server-common (<< 2.1.0-7~)
Description: Common UNIX Printing System(tm) - driverless printing
 The Common UNIX Printing System (or CUPS(tm)) is a printing system and
 general replacement for lpd and the like.  It supports the Internet
 Printing Protocol (IPP), and has its own filtering driver model for
 handling various document types.
 .
 This package provides the parts of CUPS which are needed for driverless
 printing on IPP printers with common data formats.

Package: cups-daemon
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends},
         ${misc:Depends},
         procps,
         lsb-base,
         libcups2 (= ${binary:Version}),
         ssl-cert,
         adduser,
         bc
Recommends: colord,
            cups-browsed,
            avahi-daemon
Suggests: cups,
          cups-bsd,
          cups-common (>= ${source:Version}),
          cups-server-common (>= ${source:Version}),
          cups-client (>= ${binary:Version}),
          cups-ppdc,
          cups-filters,
          poppler-utils,
          ghostscript,
          cups-filters | foomatic-filters,
          foomatic-db-compressed-ppds | foomatic-db,
          cups-pdf,
          udev,
          smbclient
Breaks: cups (<< 2.1.0-6~)
Replaces: cups (<< 2.1.0-6~)
Description: Common UNIX Printing System(tm) - daemon
 The Common UNIX Printing System (or CUPS(tm)) is a printing system and
 general replacement for lpd and the like.  It supports the Internet
 Printing Protocol (IPP), and has its own filtering driver model for
 handling various document types.
 .
 This package provides the CUPS scheduler/daemon.

Package: cups-client
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends},
         ${misc:Depends},
         cups-common (>= ${source:Version}),
         libcups2 (= ${binary:Version}),
         adduser
Suggests: cups,
          cups-bsd,
          smbclient
Conflicts: lprng
Description: Common UNIX Printing System(tm) - client programs (SysV)
 The Common UNIX Printing System (or CUPS(tm)) is a printing system and
 general replacement for lpd and the like.  It supports the Internet
 Printing Protocol (IPP), and has its own filtering driver model for
 handling various document types.
 .
 This package provides the System V style print client programs.

Package: cups-ipp-utils
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libcups2 (= ${binary:Version})
Breaks: cups-client (<< 2.0.3-2~)
Replaces: cups-client (<< 2.0.3-2~)
Description: Common UNIX Printing System(tm) - IPP developer/admin utilities
 The Common UNIX Printing System (or CUPS(tm)) is a printing system and
 general replacement for lpd and the like.  It supports the Internet
 Printing Protocol (IPP), and has its own filtering driver model for
 handling various document types.
 .
 This package provides IPP utilities for developers and system administrators

Package: libcups2-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libcupsimage2-dev (= ${binary:Version}),
         libcups2 (= ${binary:Version}),
         dpkg-dev
Description: Common UNIX Printing System(tm) - Development files CUPS library
 The Common UNIX Printing System (or CUPS(tm)) is a printing system and
 general replacement for lpd and the like.  It supports the Internet
 Printing Protocol (IPP), and has its own filtering driver model for
 handling various document types.
 .
 This package provides the files necessary for developing CUPS-aware
 applications and CUPS drivers, as well as examples how to communicate
 with cups from different programming languages (Perl, Java, and
 PHP).

Package: libcupsimage2-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libcupsimage2 (= ${binary:Version}),
         libcups2-dev (= ${binary:Version}),
         libpng-dev,
         libtiff-dev,
         libjpeg-dev,
         zlib1g-dev
Recommends: libcupsfilters-dev
Description: Common UNIX Printing System(tm) - Development files CUPS image library
 The Common UNIX Printing System (or CUPS(tm)) is a printing system and
 general replacement for lpd and the like.  It supports the Internet
 Printing Protocol (IPP), and has its own filtering driver model for
 handling various document types.
 .
 This package provides the files necessary for developing applications
 that use the CUPS raster image format.

Package: cups-bsd
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends},
         ${misc:Depends},
         cups-client (= ${binary:Version}),
         debconf | debconf-2.0,
         cups-common (>= ${source:Version})
Suggests: cups,
          inetutils-inetd | inet-superserver,
          update-inetd
Conflicts: lpr,
           lprng
Provides: lpr
Replaces: lpr
Description: Common UNIX Printing System(tm) - BSD commands
 The Common UNIX Printing System (or CUPS(tm)) is a printing system and
 general replacement for lpr, lpd and the like.  It supports the
 Internet Printing Protocol (IPP), and has its own filtering driver
 model for handling various document types.
 .
 This package provides the BSD commands for interacting with CUPS.  It
 is provided separately to allow CUPS to coexist with other printing
 systems (to a small degree).

Package: cups-common
Architecture: all
Multi-Arch: foreign
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Common UNIX Printing System(tm) - common files
 The Common UNIX Printing System (or CUPS(tm)) is a printing system and
 general replacement for lpd and the like.  It supports the Internet
 Printing Protocol (IPP), and has its own filtering driver model for
 handling various document types.
 .
 This package provides common files for CUPS server and client packages.

Package: cups-server-common
Architecture: all
Multi-Arch: foreign
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Common UNIX Printing System(tm) - server common files
 The Common UNIX Printing System (or CUPS(tm)) is a printing system and
 general replacement for lpd and the like.  It supports the Internet
 Printing Protocol (IPP), and has its own filtering driver model for
 handling various document types.
 .
 This package provides common files for CUPS server.

Package: cups-ppdc
Architecture: any
Multi-Arch: foreign
Section: utils
Depends: ${shlibs:Depends},
         ${misc:Depends},
         cups-common (>= ${source:Version})
Description: Common UNIX Printing System(tm) - PPD manipulation utilities
 The Common UNIX Printing System (or CUPS(tm)) is a printing system and
 general replacement for lpd and the like.  It supports the Internet
 Printing Protocol (IPP), and has its own filtering driver model for
 handling various document types.
 .
 This package provides utilities to generate and manipulate PPD files.

=== debian/rules ===
#!/usr/bin/make -f

derives_from_ubuntu := $(shell (dpkg-vendor --derives-from Ubuntu && echo "yes") || echo "no")

# Enabling PIE globally doesn't work, but ./configure already enables PIE
# where necessary.
export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

ifeq ($(shell dpkg-vendor --is Ubuntu && echo yes) $(DEB_HOST_ARCH), yes i386)
   skip_packages = -Ncups -Ncups-core-drivers
endif

# The build system uses only DSOFLAGS but not LDFLAGS to build some libraries.
# Add LDFLAGS to enable (hardening) build flags.
export DSOFLAGS = $(shell dpkg-buildflags --get LDFLAGS)

include /usr/share/dpkg/architecture.mk

%:
	dh $@ --without autoreconf

ifeq ($(DEB_HOST_ARCH_OS),hurd)
CONFIG_LIBUSB=--disable-libusb
else
CONFIG_LIBUSB=--enable-libusb
endif

override_dh_auto_configure:
ifeq ($(derives_from_ubuntu),yes)
	set -e; if ! [ -e debian/patches-ubuntu/stamp-applied ]; then \
	    echo '---- Applying Ubuntu specific patches'; \
	    for p in debian/patches-ubuntu/*; do \
	        patch -p1 --no-backup-if-mismatch < $$p; \
	    done; \
	    touch debian/patches-ubuntu/stamp-applied; \
	fi
endif
	# Rebuild ./configure to get build system patches working
	aclocal
	autoconf
	dh_auto_configure -- \
		--with-docdir=/usr/share/cups/doc-root \
		--localedir=/usr/share/cups/locale \
		--enable-libpaper \
		--enable-ssl \
		--enable-gnutls \
		--enable-threads \
		--enable-static \
		--enable-debug \
		--enable-dbus \
		--with-dbusdir=/etc/dbus-1 \
		--enable-gssapi \
		--enable-avahi \
		--disable-launchd \
		--with-cups-group=lp \
		--with-system-groups=lpadmin \
		--with-rundir=/run/cups \
		--with-printcap=/run/cups/printcap \
		--with-log-file-perm=0640 \
		--with-local_protocols='dnssd' \
		--with-systemd=/lib/systemd/system \
		$(CONFIG_LIBUSB)

override_dh_auto_install:
	dh_auto_install -- install BUILDROOT=$(shell pwd)/debian/tmp

MANPAGES_L10N_CUPS=man1/cups.1 man5/subscriptions.conf.5 man5/mime.convs.5 man7/filter.7 man8/cupsfilter.8 man8/cups-exec.8 man8/cups-deviced.8 man8/cups-driverd.8 man8/cupsd-helper.8 man8/cupsd-lpd.8
MANPAGES_L10N_CUPS_SERVER_COMMON=man5/cupsd-logs.conf.5
MANPAGES_L10N_CUPS_DAEMON=man5/classes.conf.5 man5/cupsd.conf.5 man5/cups-files.conf.5 man5/cups-snmp.conf.5 man5/mailto.conf.5 man5/mime.types.5 man5/printers.conf.5 man7/backend.7 man7/notifier.7 man8/cupsd.8 man8/cups-snmp.8
MANPAGES_L10N_CUPS_CLIENT=man1/cupstestppd.1 man1/lp.1 man1/lpoptions.1 man1/lppasswd.1 man1/lpstat.1 man1/cancel.1 man5/client.conf.5 man8/cupsenable.8 man8/lpadmin.8 man8/lpinfo.8 man8/lpmove.8 man8/cupsreject.8 man8/cupsdisable.8 man8/cupsaccept.8 man8/cupsctl.8
MANPAGES_L10N_CUPS_BSD=man1/lpr.1 man1/lprm.1 man1/lpq.1 man8/lpc.8
MANPAGES_L10N_CUPS_IPP_UTILS=man1/ippeveprinter.1 man1/find.1 man1/ippserver.1 man1/ipptool.1 man5/ipptoolfile.5

override_dh_installman:
	dh_installman
ifneq (,$(filter cups-server-common,$(shell dh_listpackages)))
	# Try to install the translated manpages to cups-server-common
	set -e; for m in $(MANPAGES_L10N_CUPS_SERVER_COMMON); do \
	    for manp in $$(ls debian/tmp/usr/share/man/*/$$m); do \
	        if [ -r $$manp ]; then \
	            if [ -L $$manp ]; then \
	                ln -sf $$(readlink $$manp) $$(echo $$manp | sed -e 's#^debian/tmp#debian/cups-server-common#');\
	            else \
	                install -D -m 644 $$manp $$(echo $$manp | sed -e 's#^debian/tmp#debian/cups-server-common#');\
	            fi; \
	        fi; \
	    done; \
	done
endif
ifneq (,$(filter cups,$(shell dh_listpackages)))
	# Try to install the translated manpages to cups
	set -e; for m in $(MANPAGES_L10N_CUPS); do \
	    for manp in $$(ls debian/tmp/usr/share/man/*/$$m); do \
	        if [ -r $$manp ]; then \
	            if [ -L $$manp ]; then \
	                ln -sf $$(readlink $$manp) $$(echo $$manp | sed -e 's#^debian/tmp#debian/cups#');\
	            else \
	                install -D -m 644 $$manp $$(echo $$manp | sed -e 's#^debian/tmp#debian/cups#');\
	            fi; \
	        fi; \
	    done; \
	done
endif
ifneq (,$(filter cups-daemon,$(shell dh_listpackages)))
	# Try to install the translated manpages to cups-daemon
	set -e; for m in $(MANPAGES_L10N_CUPS_DAEMON); do \
	    for manp in $$(ls debian/tmp/usr/share/man/*/$$m); do \
	        if [ -r $$manp ]; then \
	            if [ -L $$manp ]; then \
	                ln -sf $$(readlink $$manp) $$(echo $$manp | sed -e 's#^debian/tmp#debian/cups-daemon#');\
	            else \
	                install -D -m 644 $$manp $$(echo $$manp | sed -e 's#^debian/tmp#debian/cups-daemon#');\
	            fi; \
	        fi; \
	    done; \
	done
endif
ifneq (,$(filter cups-client,$(shell dh_listpackages)))
	# Try to install the translated manpages to cups-client
	set -e; for m in $(MANPAGES_L10N_CUPS_CLIENT); do \
	    for manp in $$(ls debian/tmp/usr/share/man/*/$$m); do \
	        if [ -r $$manp ]; then \
	            if [ -L $$manp ]; then \
	                ln -sf $$(readlink $$manp) $$(echo $$manp | sed -e 's#^debian/tmp#debian/cups-client#');\
	            else \
	                install -D -m 644 $$manp $$(echo $$manp | sed -e 's#^debian/tmp#debian/cups-client#');\
	            fi; \
	        fi; \
	    done; \
	done
endif
ifneq (,$(filter cups-bsd,$(shell dh_listpackages)))
	# Try to install the translated manpages to cups-bsd
	set -e; for m in $(MANPAGES_L10N_CUPS_BSD); do \
	    for manp in $$(ls debian/tmp/usr/share/man/*/$$m); do \
	        if [ -r $$manp ]; then \
	            if [ -L $$manp ]; then \
	                ln -sf $$(readlink $$manp) $$(echo $$manp | sed -e 's#^debian/tmp#debian/cups-bsd#');\
	            else \
	                install -D -m 644 $$manp $$(echo $$manp | sed -e 's#^debian/tmp#debian/cups-bsd#');\
	            fi; \
	        fi; \
	    done; \
	done
endif

ifneq (,$(filter cups-ipp-utils,$(shell dh_listpackages)))
	# Try to install the translated manpages to cups-ipp-utils
	set -e; for m in $(MANPAGES_L10N_CUPS_IPP_UTILS); do \
	    for manp in $$(ls debian/tmp/usr/share/man/*/$$m); do \
	        if [ -r $$manp ]; then \
	            if [ -L $$manp ]; then \
	                ln -sf $$(readlink $$manp) $$(echo $$manp | sed -e 's#^debian/tmp#debian/cups-ipp-utils#');\
	            else \
	                install -D -m 644 $$manp $$(echo $$manp | sed -e 's#^debian/tmp#debian/cups-ipp-utils#');\
	            fi; \
	        fi; \
	    done; \
	done
endif


override_dh_install:
	# Rename the systemd service units to cups.* instead of org.cups.cupsd.*
	set -e; for type in socket path service; do \
	    mv debian/tmp/lib/systemd/system/org.cups.cupsd.$$type debian/tmp/lib/systemd/system/cups.$$type ;\
	done
	dh_install

ifneq (,$(filter cups-server-common,$(shell dh_listpackages)))
	# Remove all files which get replaced by the ones in the cups-filters
	# package
	rm -f debian/cups-server-common/usr/share/cups/data/testprint
endif
	# Ensure that we don't ship anything in /var/run or /run
	rm -rf debian/cups*/var/run
	rm -rf debian/cups*/run

ifneq (,$(filter cups,$(shell dh_listpackages)))
	# Make the usb backend run as root, since /dev/bus/usb/* are
	# root:root in udev < 147, and cups does not use the usblp kernel
	# module any more; udev 147 makes most of those printers accessible to
	# lp, but apparently not all of them
	chmod go-x debian/cups/usr/lib/cups/backend-available/usb
endif

ifneq (,$(filter libcups2-dev,$(shell dh_listpackages)))
	# debian/libcups2-dev.install entry cannot rename files on-the-fly
	cp cups/language-private.h debian/libcups2-dev/usr/include/cups/i18n.h
endif

ifneq (,$(filter cups-daemon,$(shell dh_listpackages)))
	# Install AppArmor, ufw profile, and Apport hook
	install -D -m 644 debian/local/apparmor-profile debian/cups-daemon/etc/apparmor.d/usr.sbin.cupsd
	dh_apparmor --profile-name=usr.sbin.cupsd -p cups-daemon
	install -D -m 644 debian/local/cups.ufw.profile debian/cups-daemon/etc/ufw/applications.d/cups

=== debian/watch ===
version=4
opts="uversionmangle=s/^(release|v)?\.//;s/(rc|b)/~$1/,pgpsigurlmangle=s/$/\.sig/" \
  https://github.com/apple/cups/releases .*/cups-(release|v)?@ANY_VERSION@-source@ARCHIVE_EXT@

## cups 2.3.3

=== debian/changelog ===
cups (2.3.3-3ubuntu1) groovy; urgency=medium

  * Merged with Debian unstable. Remaining changes:
    - Added extra checking when administrative requests (create queue,
      remove someone else's job, ...) rach cupsd. If the client is a Snap,
      it has to plug the cups-control interface to be allowed to do the
      task. Added libapparmor-dev and libsnapd-glib-dev to the build
      dependencies. Also added needed permissions to AppArmor profile.
  * Build CUPS with "SystemGroup lpadmin root" in cups-files.conf by
    defualt, as CUPS always worked this way but the new patch for
    supporting the "cups-control" interface of Snaps does not allow
    implicit permission to everything for root any more.

 -- Till Kamppeter <till.kamppeter@gmail.com>  Fri,  4 Sep 2020 19:00:00 +0200

cups (2.3.3-3) unstable; urgency=medium

  [ Didier Raboud ]
  * Set lintian overrides for non-changeable upstream choices
  * Add missing Build-Depends-Package in symbols' files

  [ Till Kamppeter ]
  * Resolve DNS-SD-service-name-based URIs correctly also if they are
    from a service from localhost (like IPP-over-USB, Printer
    Application, ...)
  * Make lpoptions list a printer's options correctly also when CUPS is
    running on an alternative port
  * Fix fax numbers supplied via GTK print dialog, removing a "Custom."
    prefix; do not choke if the GTK dialog sends "None" as phone number
    or pre-dial prefix
  * Let the rastertopwg filter check rounding errors when calculating
    the page geometry

 -- Didier Raboud <odyx@debian.org>  Thu, 03 Sep 2020 09:27:04 +0200

cups (2.3.3-2ubuntu5) groovy; urgency=medium

  * In all autopkgtests modify set "LogLevel debug2" in cupsd.conf and
    "SystemGroup lpadmin root" in cups-files.conf and restart cupsd,
    the former change to more easily find out what failed and the latter
    as the default configuration did not allow root to create queues,
    making all tests fail.

 -- Till Kamppeter <till.kamppeter@gmail.com>  Thu, 27 Aug 2020 23:18:00 +0200

cups (2.3.3-2ubuntu4) groovy; urgency=medium

  * Let the rastertopwg filter check rounding errors when calculating the
    page geometry.

 -- Till Kamppeter <till.kamppeter@gmail.com>  Wed, 27 Aug 2020 10:22:00 +0200

cups (2.3.3-2ubuntu3) groovy; urgency=medium

  * Do not choke if the GTK dialog sends "None" as phone number or pre-dial
    prefix.

 -- Till Kamppeter <till.kamppeter@gmail.com>  Wed, 26 Aug 2020 22:33:00 +0200

cups (2.3.3-2ubuntu2) groovy; urgency=medium

  * Fix fax numbers supplied via GTK print dialog, removing a "Custom."
    prefix.

 -- Till Kamppeter <till.kamppeter@gmail.com>  Wed, 26 Aug 2020 13:03:00 +0200

cups (2.3.3-2ubuntu1) groovy; urgency=medium

  * Added extra checking when administrative requests (create queue,
    remove someone else's job, ...) rach cupsd. If the client is a Snap,
    it has to plug the cups-control interface to be allowed to do the
    task. Added libapparmor-dev and libsnapd-glib-dev to the build
    dependencies. Also added needed permissions to AppArmor profile.
  * Resolve DNS-SD-service-name-based URIs correctly also if they are from
    a service from localhost (like IPP-over-USB, Printer Application, ...)
  * Make lpoptions list a printer's options correctly also when CUPS is
    running on an alternative port.

 -- Till Kamppeter <till.kamppeter@gmail.com>  Tue, 25 Aug 2020 21:34:00 +0200

cups (2.3.3-2) unstable; urgency=medium

  * Add missing dh-strip-nondeterminism B-D
  * cups-daemon: Add ipp-usb Recommends

 -- Didier Raboud <odyx@debian.org>  Wed, 29 Jul 2020 09:20:56 +0200

cups (2.3.3-1) unstable; urgency=medium

  * New 2.3.3 upstream release, with the two -12 security patches

 -- Didier Raboud <odyx@debian.org>  Fri, 01 May 2020 15:28:22 +0200

cups (2.3.1-12) unstable; urgency=medium

  * Backport two security patches
    - CVE-2020-3898: heap-buffer-overflow in libcups’s ppdFindOption()
      function in ppd-mark.c
    - CVE-2019-8842: The `ippReadIO` function may under-read an extension
      field

 -- Didier Raboud <odyx@debian.org>  Sat, 25 Apr 2020 16:13:13 +0200

cups (2.3.1-11) unstable; urgency=medium

  * CI Tests: fix cups-basiccommands:
    - swap awk with sed;
    - filter stderr away from known errors
    - add missing cups-bsd depends to test lpr commands

 -- Didier Raboud <odyx@debian.org>  Mon, 24 Feb 2020 19:40:39 +0100

cups (2.3.1-10) unstable; urgency=medium

  * Add Requires=cups.socket to cups.service, to make sure they start in
    the right order
  * CI Tests: Add a test for all CUPS' basic commands, thanks to RedHat
  * Add Pre-Depends: ${misc:Pre-Depends} to cups-daemon to fix
    skip-systemd-native-flag-missing-pre-depends lintian flag
  * Add patch proposal from RedHat to fix leakage of ppd (Issue: #5738)

 -- Didier Raboud <odyx@debian.org>  Mon, 24 Feb 2020 12:25:39 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: cups
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Printing Team <debian-printing@lists.debian.org>
+Maintainer: Debian Printing Team <debian-printing@lists.debian.org>
 Uploaders: Didier Raboud <odyx@debian.org>,
            Till Kamppeter <till.kamppeter@gmail.com>
 Section: net
 Priority: optional
 Build-Depends: debhelper-compat (= 12),
                dh-apparmor,
+               dh-strip-nondeterminism,
                patch,
                autoconf,
                automake,
@@ -30,6 +30,8 @@
                libsystemd-dev [linux-any],
                libtiff-dev,
                libusb-1.0-0-dev [!hurd-any],
+               libapparmor-dev,
+               libsnapd-glib-dev,
                po4a,
                po-debconf,
                poppler-utils,
@@ -137,6 +139,7 @@
 Package: cups-daemon
 Architecture: any
 Multi-Arch: foreign
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends},
          ${misc:Depends},
          procps,
@@ -147,7 +150,8 @@
          bc
 Recommends: colord,
             cups-browsed,
-            avahi-daemon
+            avahi-daemon,
+            ipp-usb,
 Suggests: cups,
           cups-bsd,
           cups-common (>= ${source:Version}),

=== debian/rules ===
--- 
+++ 
@@ -60,6 +60,7 @@
 		--with-log-file-perm=0640 \
 		--with-local_protocols='dnssd' \
 		--with-systemd=/lib/systemd/system \
+		--with-system-groups='lpadmin root' \
 		$(CONFIG_LIBUSB)
 
 override_dh_auto_install:

## cups 2.3.3op1

=== debian/changelog ===
cups (2.3.3op1-2) unstable; urgency=medium

  * Backport upstream "Force a 5 second sleep to wait for the job control file
    to be written" patch, to address s390x test suite timing issue

 -- Didier Raboud <odyx@debian.org>  Sat, 28 Nov 2020 16:50:59 +0100

cups (2.3.3op1-1) unstable; urgency=medium

  * Use OpenPrinting CUPS fork instead of Apple's codebase
    - Update d/upstream/metadata, d/watch
    - d/upstream/signing-key.asc: Swap Apple's with Michael R Sweet's
  * Large patch-suite cleanup thanks to lots of Debian proposals merged
    upstream; from 40 to 9;
    - Reorder (upstream-mergeable first, Debian-specific later)
    - Reword and refresh metadata for the last patches
  * Set Debian customizations in d/rules instead of patches;
    - Set --with-max-log-size=0
    - Set --enable-sync-on-close
    - Set --with-error-policy=retry-job
  * Packaging cleanup;
    - Drop the Debian-specific systemd units' renaming, now upstream
    - Drop pre-oldstable postinst ConfigFilePerm handling
    - Add missing BSD-2-Clause block in debian/copyright
    - Convert debian/po files to UTF-8
    - Drop --as-needed as it's now default in Debian
    - Drop Ubuntu-specific patch handling, in favour of compile-time option
      for --disable-browsing
    - Bump S-V to 4.5.1 without changes needed
    - Use debian/main as head branch; update d/gbp.conf accordingly
    - Drop outdated d/source/options
   * Refresh manpage translation pofiles for 2.3.3op1

 -- Didier Raboud <odyx@debian.org>  Fri, 27 Nov 2020 17:27:21 +0100

cups (2.3.3-4) unstable; urgency=medium

  * Drop Ubuntu "Make lpoptions list a printer's options correctly also when
    CUPS is running on an alternative port" patch, refused upstream
    (Closes: #970725)
  * Use upstream-merged patches for fax numbers' fix and rastertopwg rounding

 -- Didier Raboud <odyx@debian.org>  Tue, 24 Nov 2020 08:49:46 +0100

=== debian/control ===
--- 
+++ 
@@ -30,8 +30,6 @@
                libsystemd-dev [linux-any],
                libtiff-dev,
                libusb-1.0-0-dev [!hurd-any],
-               libapparmor-dev,
-               libsnapd-glib-dev,
                po4a,
                po-debconf,
                poppler-utils,
@@ -39,7 +37,7 @@
                zlib1g-dev
 # libgmp-dev is not GPL-2 compatible before it's 6 release, which makes it also GPL-2+
 Build-Conflicts: libgmp-dev (<< 2:6)
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/printing-team/cups
 Vcs-Git: https://salsa.debian.org/printing-team/cups.git
 Homepage: https://www.cups.org/

=== debian/tests/control ===
Tests: cups-core-drivers
Restrictions: needs-root
Depends: cups-core-drivers, cups-client

Tests: cups
Restrictions: needs-root
Depends: cups, cups-client

Tests: cups-basiccommands
Restrictions: needs-root
Depends: cups, cups-client, cups-bsd
